Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition le_plus_to_le : forall (a:nat), forall (n:nat), forall (m:nat), (le (plus a n) (plus a m)) -> le n m := fun (a:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (n:nat), forall (m:nat), (le (plus _x_365 n) (plus _x_365 m)) -> le n m)) (fun (n:nat) => fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le (plus O n) (y m)) -> le n m)) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le (y n) (filter_nat_type (nat -> nat) plus_body O m)) -> le n m)) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le (y n) (filter_nat_type (nat -> nat) plus_body O m)) -> le n m)) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le (plus_body O n) (y m)) -> le n m)) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le (plus_body O n) (y m)) -> le n m)) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le (y n) m) -> le n m)) (fun (auto:le n m) => (auto))))))))) (fun (x_366:nat) => fun (_x_368:forall (n:nat), forall (m:nat), (le (plus x_366 n) (plus x_366 m)) -> le n m) => (fun (n:nat) => fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => (le (plus (S x_366) n) (y m)) -> le n m)) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => (le (y n) (filter_nat_type (nat -> nat) plus_body (S x_366) m)) -> le n m)) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => (le (y n) (filter_nat_type (nat -> nat) plus_body (S x_366) m)) -> le n m)) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => (le (plus_body (S x_366) n) (y m)) -> le n m)) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => (le (plus_body (S x_366) n) (y m)) -> le n m)) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => (le (y n) (S (plus x_366 m))) -> le n m)) (fun (auto:le (S (plus x_366 n)) (S (plus x_366 m))) => (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) ((((_x_368) (S n)) (S m)) (((((logic.eq_coerc) (le (S (plus x_366 n)) (S (plus x_366 m)))) (le (plus x_366 (S n)) (plus x_366 (S m)))) (auto)) (((((((logic.rewrite_r) (nat)) (plus x_366 (S n))) (fun (__:nat) => logic.eq (Prop) (le __ (S (plus x_366 m))) (le (plus x_366 (S n)) (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (Prop) (le (plus x_366 (S n)) __) (le (plus x_366 (S n)) (plus x_366 (S m))))) (((logic.refl) (Prop)) (le (plus x_366 (S n)) (plus x_366 (S m))))) (S (plus x_366 m))) (((plus_n_Sm) (x_366)) (m)))) (S (plus x_366 n))) (((plus_n_Sm) (x_366)) (n))))))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n))))))))))))) (a).
